/////////////////////////////////////////////////
//Beispiel aus Kapitel Bibliotheken: toxiclips
//2D Simplex-Noise4 zum zeichnen eines 3D-Musters
/////////////////////////////////////////////////
import toxi.math.noise.*;

void setup() {
	smooth(0);
	size(1000, 1000, P3D);
	background(0);
	//stroke(255);
 // strokeWeight(1);
  noStroke();
	fill(255,0,0);
	float xstart = random(10);//Zufällige Startwerte damit ...
	float ynoise = random(1);//das Bild immer anders aussieht.
	translate(width / 2, height / 2, 0);
	for (float y = -(height / 10); y <= (height / 10); y += 0.5) {
		if(y!=0){
      ynoise += 0.2/abs(y);//nächster y-Parameter
    }else{ynoise += 0.005;}
		float xnoise = xstart;
		for (float x = -(width / 10); x <= (width / 10); x += 0.5) {
			//nächster x-Parameter
      if(x!=0){
         xnoise += 0.2/abs(x);
      }else{xnoise += 0.005;}  
      if(x>=(height/10)& y%10==0) {//Farbwechsel bei dieser Bedingung
        fill(random(255),random(255),random(255));}
        float noiseFaktor =abs((float)SimplexNoise.noise(xnoise, ynoise));
  			drawPoint(x, y, noiseFaktor);
		}
	}
}
//Die zeichnePunkt-Methode nutzt SimplexNoise nur für zwei Koordinaten
void drawPoint(float x, float y, float noiseFaktor) {
	pushMatrix();
  	translate(x * noiseFaktor* noiseFaktor*6, y * noiseFaktor* noiseFaktor*6, x*y/50);
  	float edgeSize = noiseFaktor * 3;
  	ellipse(0, 0, edgeSize, edgeSize);
	popMatrix();
}